VERSION 5.00
Begin VB.UserControl axCool 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   450
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6435
   MaskColor       =   &H00C0C0C0&
   PropertyPages   =   "axCool.ctx":0000
   ScaleHeight     =   30
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   429
   ToolboxBitmap   =   "axCool.ctx":0010
   Begin axCoolbar.axCoolButton btnCool 
      Height          =   330
      Index           =   1
      Left            =   45
      TabIndex        =   0
      ToolTipText     =   "Button1"
      Top             =   45
      Visible         =   0   'False
      Width           =   330
      _ExtentX        =   582
      _ExtentY        =   582
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      MaskColor       =   -2147483633
   End
Attribute VB_Name = "axCool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit
'Default Property Values:
Const m_def_BorderStyle = 2
'Property Variables:
Private m_BorderStyle As Integer
Private mNodes As New CollectionEx
Private bShowFlatGrey As Boolean
Private bTextLabels As Boolean
Public Enum AxBorderStyles
    [No Border] = 0
    [Single] = 1
    [Thin Raised] = 2
    [Thick Raised] = 3
    [Thin Inset] = 4
    [Thick Inset] = 5
    [Etched] = 6
    [Bump] = 7
End Enum
'Event Declarations:
Event Click(Index As Integer)
Attribute Click.VB_Description = "Occurs when the button is pushed"
Event DropDownClick(Index As Integer)
Attribute DropDownClick.VB_Description = "Occurs when the dropdown button is clicked"
Private Sub btnCool_Click(Index As Integer)
  RaiseEvent Click(Index)
End Sub
Private Sub btnCool_DropDownClick(Index As Integer)
  RaiseEvent DropDownClick(Index)
End Sub
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_BorderStyle = m_def_BorderStyle
    bShowFlatGrey = False
    bTextLabels = False
    UserControl.Height = 400
    UserControl.Width = 6435
End Sub
Private Sub UserControl_Paint()
    Dim di As Long
    Dim rc As RECT
    'draw outside border
        
    Select Case m_BorderStyle
        Case [No Border]
        
        Case [Single]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, BDR_RAISEDOUTER, BF_RECT Or BF_MONO)
        
        Case [Thin Raised]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, BDR_RAISEDINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, BDR_RAISEDOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Raised]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, EDGE_RAISED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, EDGE_RAISED, BF_BOTTOMRIGHT)
        Case [Thin Inset]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, BDR_SUNKENINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, BDR_SUNKENOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Inset]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, EDGE_SUNKEN, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)
        
        Case [Etched]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, EDGE_ETCHED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, EDGE_ETCHED, BF_BOTTOMRIGHT)
        Case [Bump]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hdc, rc, EDGE_BUMP, BF_TOPLEFT)
            di = DrawEdge(UserControl.hdc, rc, EDGE_BUMP, BF_BOTTOMRIGHT)
            
    End Select
        
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim iTotCnt As Integer, Index As Integer
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    bShowFlatGrey = PropBag.ReadProperty("ShowFlatGrey", False)
    bTextLabels = PropBag.ReadProperty("TextLabels", False)
        
        iTotCnt = PropBag.ReadProperty("Count", 0)
        'ReDim mOtlData(totcnt)
        For Index = 1 To iTotCnt
          AddItem
          Set mNodes.Item(Index).Bitmap = PropBag.ReadProperty("List_1" & Index, Nothing)
          mNodes.Item(Index).Caption = PropBag.ReadProperty("List_2" & Index, "")
          mNodes.Item(Index).Enabled = PropBag.ReadProperty("List_3" & Index, 1)
          mNodes.Item(Index).Style = PropBag.ReadProperty("List_4" & Index, 0)
          mNodes.Item(Index).Tag = PropBag.ReadProperty("List_5" & Index, "")
          mNodes.Item(Index).ToolTipText = PropBag.ReadProperty("List_6" & Index, "")
          mNodes.Item(Index).Visible = PropBag.ReadProperty("List_7" & Index, 1)
          mNodes.Item(Index).DropDown = PropBag.ReadProperty("List_8" & Index, 0)
        Next
        
      ShowButtons
End Sub
Private Sub UserControl_Resize()
  If bTextLabels Then
    UserControl.Height = 720
  Else
    UserControl.Height = 400
  End If
  UserControl.Cls
  UserControl_Paint
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Dim Index As Integer
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("ShowFlatGrey", bShowFlatGrey, False)
    Call PropBag.WriteProperty("TextLabels", bTextLabels, False)
    Call PropBag.WriteProperty("Count", mNodes.Count, 0)
    For Index = 1 To mNodes.Count
      Call PropBag.WriteProperty("List_1" & Index, mNodes(Index).Bitmap)
      Call PropBag.WriteProperty("List_2" & Index, mNodes(Index).Caption)
      Call PropBag.WriteProperty("List_3" & Index, mNodes(Index).Enabled)
      Call PropBag.WriteProperty("List_4" & Index, mNodes(Index).Style)
      Call PropBag.WriteProperty("List_5" & Index, mNodes(Index).Tag)
      Call PropBag.WriteProperty("List_6" & Index, mNodes(Index).ToolTipText)
      Call PropBag.WriteProperty("List_7" & Index, mNodes(Index).Visible)
      Call PropBag.WriteProperty("List_8" & Index, mNodes(Index).DropDown)
    Next
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
Sub ShowAboutBox()
Attribute ShowAboutBox.VB_Description = "Show About box"
Attribute ShowAboutBox.VB_UserMemId = -552
  frmAbout.Show vbModal
  Unload frmAbout
  Set frmAbout = Nothing
End Sub
Public Property Get BorderStyle() As AxBorderStyles
Attribute BorderStyle.VB_Description = "Returns/sets the border style for the control."
    BorderStyle = m_BorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As AxBorderStyles)
    If Not (m_BorderStyle = New_BorderStyle) Then
        m_BorderStyle = New_BorderStyle
        UserControl.Cls
        UserControl_Paint
    End If
    PropertyChanged "BorderStyle"
End Property
''MappingInfo=UserControl,UserControl,-1,Ambient
'Public Property Get Ambient() As AmbientProperties
'  Set Ambient = UserControl.Ambient
'End Property
Public Function Item(ByVal Key As Variant) As Object
Attribute Item.VB_Description = "Sets/gets information on a specific button"
  If VarType(Key) = vbString Then
    Key = Trim(Key)
  End If
  Set Item = mNodes.Item(Key)
End Function
Public Sub AddItem()
Attribute AddItem.VB_Description = "Add blank button to buttons collection"
Attribute AddItem.VB_MemberFlags = "40"
  Dim NewItem As New clsItem, cnt As Integer
  With NewItem
    .Caption = ""
    .Style = 0
    .Tag = ""
    .ToolTipText = ""
    .Visible = 1
    .Enabled = 1
    .DropDown = 0
    Set .Bitmap = Nothing
  End With
  mNodes.Add NewItem, LTrim(Str(mNodes.Count + 1))
End Sub
Public Property Get Count() As Integer
Attribute Count.VB_Description = "Returns number of buttons in button collection"
  Count = mNodes.Count
End Property
Public Sub Remove(Index As Integer)
Attribute Remove.VB_Description = "Removes a specific button"
Attribute Remove.VB_MemberFlags = "40"
  mNodes.Remove Index
End Sub
Public Sub ShowButtons()
Attribute ShowButtons.VB_Description = "Show all buttons"
Attribute ShowButtons.VB_MemberFlags = "40"
  'delete and recreate all buttons
  Dim cnt As Integer, currX As Integer
  Dim iWidth As Integer, iHeight As Integer
  RemoveButtons
  If mNodes.Count = 0 Then
    btnCool(1).Visible = False
  Else
    btnCool(1).Visible = False
    If mNodes.Item(1).DropDown And (mNodes.Item(1).Style = [Cool Button] Or mNodes.Item(1).Style = [Standard Button] Or mNodes.Item(1).Style = [Toolbar Button]) Then
        iWidth = IIf(bTextLabels, 52, 32)
    ElseIf mNodes.Item(1).Style = Separator Or mNodes.Item(1).Style = [Toolbar Handle] Then
        iWidth = 9
    Else
        iWidth = IIf(bTextLabels, 44, 22)
    End If
    iHeight = IIf(bTextLabels, 44, 22)
    btnCool(1).Move 2, 2, iWidth, iHeight
    btnCool(1).Enabled = mNodes.Item(1).Enabled
    btnCool(1).DropDown = mNodes.Item(1).DropDown
    btnCool(1).Caption = IIf(bTextLabels, mNodes.Item(1).Caption, "")
    btnCool(1).ToolTipText = mNodes.Item(1).ToolTipText
    btnCool(1).Tag = mNodes.Item(1).Tag
    btnCool(1).Style = mNodes.Item(1).Style
    btnCool(1).ShowFlatGrey = bShowFlatGrey
    btnCool(1).PictureAlign = vbPicTop
    Set btnCool(1).Picture = IIf(mNodes.Item(1).Bitmap Is Nothing, Nothing, mNodes.Item(1).Bitmap)
    mNodes.Item(1).Left = btnCool(1).Left
    btnCool(1).Visible = mNodes.Item(1).Visible
    For cnt = 2 To mNodes.Count
      Load btnCool(cnt)
      
      btnCool(cnt).Visible = False
      If mNodes.Item(cnt).DropDown And (mNodes.Item(cnt).Style = [Cool Button] Or mNodes.Item(cnt).Style = [Standard Button] Or mNodes.Item(cnt).Style = [Toolbar Button]) Then
        iWidth = IIf(bTextLabels, 52, 32)
      ElseIf mNodes.Item(cnt).Style = Separator Or mNodes.Item(cnt).Style = [Toolbar Handle] Then
        iWidth = 9
      Else
        iWidth = IIf(bTextLabels, 44, 22)
      End If
      iHeight = IIf(bTextLabels, 44, 22)
      btnCool(cnt).Move btnCool(cnt - 1).Left + btnCool(cnt - 1).Width + 1, 2, iWidth, iHeight
      
      btnCool(cnt).DropDown = mNodes.Item(cnt).DropDown
      btnCool(cnt).Enabled = mNodes.Item(cnt).Enabled
      btnCool(cnt).Caption = IIf(bTextLabels, mNodes.Item(cnt).Caption, "")
      btnCool(cnt).ToolTipText = mNodes.Item(cnt).ToolTipText
      btnCool(cnt).Tag = mNodes.Item(cnt).Tag
      btnCool(cnt).Style = mNodes.Item(cnt).Style
      btnCool(cnt).ShowFlatGrey = bShowFlatGrey
      btnCool(cnt).PictureAlign = vbPicTop
      Set btnCool(cnt).Picture = IIf(mNodes.Item(cnt).Bitmap Is Nothing, Nothing, mNodes.Item(cnt).Bitmap)
      mNodes.Item(cnt).Left = btnCool(cnt).Left * Screen.TwipsPerPixelX
      btnCool(cnt).Visible = mNodes.Item(cnt).Visible
    Next
  End If
End Sub
Public Sub RedrawButtons()
Attribute RedrawButtons.VB_Description = "Redraws all buttons from the button collection"
Attribute RedrawButtons.VB_MemberFlags = "40"
  'delete and recreate all buttons
  ShowButtons
  PropertyChanged "Buttons"
End Sub
Public Sub UpdateButtons()
  'redraw all buttons (no delete)
  Dim cnt As Integer, currX As Integer
  Dim iWidth As Integer, iHeight As Integer
  If mNodes.Count = 0 Then
    btnCool(1).Visible = False
  Else
    btnCool(1).Visible = False
    If mNodes.Item(1).DropDown And (mNodes.Item(1).Style = [Cool Button] Or mNodes.Item(1).Style = [Standard Button] Or mNodes.Item(1).Style = [Toolbar Button]) Then
        iWidth = IIf(bTextLabels, 52, 32)
    ElseIf mNodes.Item(1).Style = Separator Or mNodes.Item(1).Style = [Toolbar Handle] Then
        iWidth = 9
    Else
        iWidth = IIf(bTextLabels, 44, 22)
    End If
    iHeight = IIf(bTextLabels, 44, 22)
    btnCool(1).Move 2, 2, iWidth, iHeight
    btnCool(1).Enabled = mNodes.Item(1).Enabled
    btnCool(1).DropDown = mNodes.Item(1).DropDown
    btnCool(1).Caption = IIf(bTextLabels, mNodes.Item(1).Caption, "")
    btnCool(1).ToolTipText = mNodes.Item(1).ToolTipText
    btnCool(1).Tag = mNodes.Item(1).Tag
    btnCool(1).Style = mNodes.Item(1).Style
    btnCool(1).ShowFlatGrey = bShowFlatGrey
    btnCool(1).PictureAlign = vbPicTop
    Set btnCool(1).Picture = IIf(mNodes.Item(1).Bitmap Is Nothing, Nothing, mNodes.Item(1).Bitmap)
    mNodes.Item(1).Left = btnCool(1).Left
    btnCool(1).Visible = mNodes.Item(1).Visible
    For cnt = 2 To mNodes.Count
      btnCool(cnt).Visible = False
      If mNodes.Item(cnt).DropDown And (mNodes.Item(cnt).Style = [Cool Button] Or mNodes.Item(cnt).Style = [Standard Button] Or mNodes.Item(cnt).Style = [Toolbar Button]) Then
        iWidth = IIf(bTextLabels, 52, 32)
      ElseIf mNodes.Item(cnt).Style = Separator Or mNodes.Item(cnt).Style = [Toolbar Handle] Then
        iWidth = 9
      Else
        iWidth = IIf(bTextLabels, 44, 22)
      End If
      iHeight = IIf(bTextLabels, 44, 22)
      btnCool(cnt).Move btnCool(cnt - 1).Left + btnCool(cnt - 1).Width + 1, 2, iWidth, iHeight
      
      btnCool(cnt).DropDown = mNodes.Item(cnt).DropDown
      btnCool(cnt).Enabled = mNodes.Item(cnt).Enabled
      btnCool(cnt).Caption = IIf(bTextLabels, mNodes.Item(cnt).Caption, "")
      btnCool(cnt).ToolTipText = mNodes.Item(cnt).ToolTipText
      btnCool(cnt).Tag = mNodes.Item(cnt).Tag
      btnCool(cnt).Style = mNodes.Item(cnt).Style
      btnCool(cnt).ShowFlatGrey = bShowFlatGrey
      btnCool(cnt).PictureAlign = vbPicTop
      Set btnCool(cnt).Picture = IIf(mNodes.Item(cnt).Bitmap Is Nothing, Nothing, mNodes.Item(cnt).Bitmap)
      mNodes.Item(cnt).Left = btnCool(cnt).Left * Screen.TwipsPerPixelX
      btnCool(cnt).Visible = mNodes.Item(cnt).Visible
    Next
  End If
End Sub
Private Sub RemoveButtons()
Attribute RemoveButtons.VB_Description = "Remove all buttons"
'remove all buttons from control except base one
Dim cnt As Integer
If btnCool().Count > 1 Then
  For cnt = 2 To btnCool().Count
    Unload btnCool(cnt)
  Next
End If
End Sub
Public Property Get ShowFlatGrey() As Boolean
Attribute ShowFlatGrey.VB_Description = "Get/Sets a value to determine whether or not to display the picture in greyscale when the mouse is not over the button (Cool Button only)"
    ShowFlatGrey = bShowFlatGrey
End Property
Public Property Let ShowFlatGrey(ByVal New_Value As Boolean)
    bShowFlatGrey = New_Value
    UpdateButtons
    PropertyChanged "ShowFlatGrey"
End Property
Public Property Get TextLabels() As Boolean
Attribute TextLabels.VB_Description = "Sets/gets a value to determine whether buttons will show the  text label"
    TextLabels = bTextLabels
End Property
Public Property Let TextLabels(ByVal New_Value As Boolean)
    bTextLabels = New_Value
    UserControl_Resize
    UpdateButtons
    PropertyChanged "TextLabels"
End Property
